import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class CounterTerrorist here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class CounterTerrorist extends Pedestrian
{

    private GreenfootImage ct = new GreenfootImage("ct.png");
    private  GreenfootSound go = new GreenfootSound("gogogo.wav");
    private GreenfootSound kgo = new GreenfootSound("kletsgo.wav");
    private GreenfootSound hit = new GreenfootSound("imhit.wav");
    private GreenfootSound eDown = new GreenfootSound("enemydown.wav");

    private int myWidth;
    private boolean healthy;
    private int speed = 2;
    private boolean isDead = false;
    private boolean dragged = false;

    public CounterTerrorist()
    {
        setImage(ct);
        if (Greenfoot.getRandomNumber(2) == 1)
        {
            go.play();
        }
        else
        {
            kgo.play();
        }
        GreenfootImage g = this.getImage();
        myWidth = g.getWidth();
    }

    /**
     * Act - do whatever the CounterTerrorist wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // move upwards
        setLocation (getX(), getY() - speed);
        // check if I'm at the edge of the world,
        // and if so, remove myself
        drag();
        if (atWorldEdge())
        {
            ((MyWorld)getWorld()).resetCtCount();
            getWorld().removeObject(this);
        }
    }    

    private boolean isWinFight()
    {
        if (Greenfoot.getRandomNumber(2) == 1)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    /**
     * Method causes this Pedestrian to stop moving
     * and appear to fall over
     */
    public void knockMeOver ()
    {
        if (isDead == false)
        {
            if (isWinFight() == true)
            {
                Vehicle  v;
                v = (Vehicle)getOneIntersectingObject(Vehicle.class);
                ((MyWorld)getWorld()).removeObject(v);
                eDown.play();
            }
            else
            {
                speed = 0;
                setRotation (90);
                playDeathSound();
                isDead = true;
            }
        }
    }

    /**
     * Method causes this pedestrian to "heal" - regain
     * upright position and start moving again
     */
    public void healMe ()
    {
        if (isDead == true)
        {
            speed = 2;
            setRotation (0);
            healed.play();
            isDead = false;
        }
    }

    /**
     * Handy method that checks if this object is at the edge
     * of the World
     */
    public boolean atWorldEdge()
    {
        if (getX() < -(myWidth / 2) || getX() > getWorld().getWidth() + (myWidth / 2))
            return true;
        else if (getY() < -(myWidth / 2) || getY () > getWorld().getHeight() + (myWidth / 2))
            return true;
        else
            return false;
    }

    /**
     * Method that plays a sound effect when the pedestrian is run over
     */
    public void playDeathSound()
    {
        hit.play();
    }

    /**
     * Method that allows a bus to drag dead pedestrians off screen
     */
    public void drag()
    {
        if (isDead == true)
        {
            Draggers b = (Draggers)getOneIntersectingObject(Draggers.class);

            if (b != null)
            {
                setLocation(b.getX() - 20, b.getY());
                if (dragged == false)
                {
                    setRotation(270);
                    playDeathSound();
                    dragged = true;
                }
            }
        }
    }
}
