import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Reimu here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Reimu extends Pedestrian
{
    private  GreenfootSound death1 = new GreenfootSound("reimudeath.wav");
    private GreenfootSound touhou = new GreenfootSound("touhou.wav");

    private GreenfootImage f1 = new GreenfootImage("player/playerforward.png");
    private GreenfootImage f2 = new GreenfootImage("player/playerforward2.png");
    private  GreenfootImage f3 = new GreenfootImage("player/playerforward3.png");
    private  GreenfootImage f4 = new GreenfootImage("player/playerforward4.png");

    private  GreenfootImage l1 = new GreenfootImage("player/playerleft.png");
    private GreenfootImage l2 = new GreenfootImage("player/playerleft2.png");
    private  GreenfootImage l3 = new GreenfootImage("player/playerleft3.png");
    private  GreenfootImage l4 = new GreenfootImage("player/playerleft4.png");
    private GreenfootImage l5 = new GreenfootImage("player/playerleft5.png");
    private GreenfootImage l6 = new GreenfootImage("player/playerleft6.png");

    private  GreenfootImage r1 = new GreenfootImage("player/playerright.png");
    private  GreenfootImage r2 = new GreenfootImage("player/playerright2.png");
    private  GreenfootImage r3 = new GreenfootImage("player/playerright3.png");
    private  GreenfootImage r4 = new GreenfootImage("player/playerright4.png");
    private  GreenfootImage r5 = new GreenfootImage("player/playerright5.png");
    private  GreenfootImage r6 = new GreenfootImage("player/playerright6.png");

    private String upKey = "w";
    private String downKey = "s";
    private String leftKey = "a";
    private String rightKey = "d";
    private String shootKey = "l";
    private String focusKey = "shift";

    private final int moveSpeed = 3; //Default value: 3
    private final int animSpd = 6;
    private final int atkSpd = 5;
    private int atkTimer = 0;

    private int focusMode = 0;

    private int myWidth;
    private boolean healthy;
    private int speed = 2;
    private boolean isDead = false;
    private boolean dragged = false;
    private int timer = 0;
    private boolean justSpawned = true;
    private boolean keyPressed = false;

    /**
     * Act - do whatever the Reimu wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if (keyPressed == false)
            setLocation (getX(), getY() - speed);
        if (isDead == false)
        {
            touhou.play();
            getMovement();
        }
        // check if I'm at the edge of the world,
        // and if so, remove myself
        drag();
        if (atWorldEdge())
        {
            touhou.stop();
            ((MyWorld)getWorld()).resetReimuCount();
            getWorld().removeObject(this);
        }
    }    

    public void knockMeOver ()
    {
        if (isDead == false)
        {
            touhou.stop();
            speed = 0;
            setRotation (270);
            playDeathSound();
            isDead = true;
        }
    }

    /**
     * Method causes this pedestrian to "heal" - regain
     * upright position and start moving again
     */
    public void healMe ()
    {
        if (isDead == true)
        {
            speed = 2;
            setRotation (0);
            healed.play();
            isDead = false;
        }
    }

    /**
     * Handy method that checks if this object is at the edge
     * of the World
     */
    public boolean atWorldEdge()
    {
        if (getX() < -(myWidth / 2) || getX() > getWorld().getWidth() + (myWidth / 2))
            return true;
        else if (getY() < -(myWidth / 2) || getY () > getWorld().getHeight() + (myWidth / 2))
            return true;
        else
            return false;
    }

    /**
     * Method that plays a sound effect when the pedestrian is run over
     */
    public void playDeathSound()
    {
        death1.play();
    }

    /**
     * Method that allows a bus to drag dead pedestrians off screen
     */
    public void drag()
    {
        if (isDead == true)
        {
            Draggers b = (Draggers)getOneIntersectingObject(Draggers.class);

            if (b != null)
            {
                setLocation(b.getX() - 20, b.getY());
                if (dragged == false)
                {
                    setRotation(270);
                    playDeathSound();
                    dragged = true;
                }
            }
        }
    }

    private void getMovement()
    {
        if (Greenfoot.isKeyDown(upKey) == true && Greenfoot.isKeyDown(leftKey) == true)
        {
            setLocation(getX()-(moveSpeed - focusMode),getY()-(moveSpeed - focusMode));
            leftAnim();
        } 
        else if (Greenfoot.isKeyDown(downKey) == true && Greenfoot.isKeyDown(leftKey) == true)
        {
            setLocation(getX()-(moveSpeed - focusMode),getY()+(moveSpeed - focusMode));
            leftAnim();
        }
        else if (Greenfoot.isKeyDown(upKey) == true && Greenfoot.isKeyDown(rightKey) == true)
        {
            setLocation(getX()+(moveSpeed - focusMode),getY()-(moveSpeed - focusMode));
            rightAnim();
        }
        else if (Greenfoot.isKeyDown(downKey) == true && Greenfoot.isKeyDown(rightKey) == true)
        {
            setLocation(getX()+(moveSpeed - focusMode),getY()+(moveSpeed - focusMode));
            rightAnim();
        }

        else if (Greenfoot.isKeyDown(upKey) == true)
        {
            setLocation(getX(), getY()-(moveSpeed - focusMode));
            idleAnim();
        } 
        else if (Greenfoot.isKeyDown(leftKey) == true)
        {
            setLocation(getX()-(moveSpeed - focusMode),getY());
            leftAnim();
        }  
        else if (Greenfoot.isKeyDown(downKey) == true)
        {
            setLocation(getX(),getY()+(moveSpeed - focusMode));
            idleAnim();
        } 
        else if (Greenfoot.isKeyDown(rightKey) == true)
        {
            setLocation(getX()+(moveSpeed - focusMode),getY());
            rightAnim();
        }
        else if (Greenfoot.isKeyDown(upKey) == false && Greenfoot.isKeyDown(leftKey) == false && Greenfoot.isKeyDown(downKey) == false &&Greenfoot.isKeyDown(rightKey) == false
        || Greenfoot.isKeyDown(focusKey) == false)
        {
            idleAnim();
        }
        else
        {
            timer = 0;
        }
        if (Greenfoot.isKeyDown(focusKey) == true)
        {
            focusMode = 1;
        } else
        {
            focusMode = 0;
        }
        if(Greenfoot.isKeyDown("space") == true)
        {
            keyPressed = true;
        }
    }

    private void idleAnim()
    {
        switch (timer) {
            case 0: setImage(f1);
            break;
            case (animSpd*1): setImage(f2);
            break;
            case (animSpd*2): setImage(f3);
            break;
            case (animSpd*3): setImage(f4);
            break;
            case (animSpd*4): timer = 0;
            break;
        }
        timer++;     
    }

    private void leftAnim()
    {
        switch (timer){
            case 0: setImage(l3);
            break;
            case (animSpd*1): setImage(l4);
            break;
            case (animSpd*2): setImage(l5);
            break;
            case (animSpd*3): setImage(l6);
            break;
            case (animSpd*4):  timer = 0;
            break;
        }
        timer++;
    }

    private void rightAnim()
    {
        switch (timer){
            case 0: setImage(r3);
            break;
            case (animSpd*1): setImage(r4);
            break;
            case (animSpd*2): setImage(r5);
            break;
            case (animSpd*3): setImage(r6);
            break;
            case (animSpd*4):  timer = 0;
            break;
        }
        timer++;
    }
}

