import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.Random;
/**
 * Write a description of class Trolldestrian here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */

public class Trolldestrian extends Pedestrian
{

    private GreenfootSound troll = new GreenfootSound("troll.wav");
    private boolean isTrolling = false;
    private int rotation = 0;
    private int myWidth;
    private boolean healthy;
    private int speed = 2;
    private boolean isDead = false;
    private boolean dragged = false;
    /**
     * Act - do whatever the Trolldestrian wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // move upwards
        setLocation (getX(), getY() - speed);
        // check if I'm at the edge of the world,
        // and if so, remove myself
        trollSound();
        trollSpin();
        drag();
        if (atWorldEdge())
        {
            troll.stop();
            getWorld().removeObject(this);
        }
    }    

    private void trollSpin()
    {
        if (isDead == false)
        {
            if (rotation > 360)
            {
                rotation = 0;
            }
            setRotation(rotation);
            rotation+= 15;
        }
    }

    private void trollSound()
    {
        if (isTrolling == false)
        {
            troll.play();
            isTrolling = true;
        }

    }

    /**
     * Method causes this pedestrian to "heal" - regain
     * upright position and start moving again
     */
    public void healMe ()
    {
        if (isDead == true)
        {
            speed = 2;
            setRotation (0);
            healed.play();
            isDead = false;
            isTrolling = false;
        }
    }

    /**
     * Method causes this Pedestrian to stop moving
     * and appear to fall over
     */
    public void knockMeOver ()
    {
        if (isDead == false)
        {
            speed = 0;
            setRotation (90);
            playDeathSound();
            isDead = true;
            troll.stop();
        }
    }

    /**
     * Handy method that checks if this object is at the edge
     * of the World
     */
    public boolean atWorldEdge()
    {
        if (getX() < -(myWidth / 2) || getX() > getWorld().getWidth() + (myWidth / 2))
            return true;
        else if (getY() < -(myWidth / 2) || getY () > getWorld().getHeight() + (myWidth / 2))
            return true;
        else
            return false;
    }

    /**
     * Method that plays a sound effect when the pedestrian is run over
     */
    public void playDeathSound()
    {
        Random r = new Random();
        int a;
        a = r.nextInt(6);
        switch (a)
        {
            case 0:
            death1.play();
            break;
            case 1:
            death2.play();
            break;
            case 2:
            death3.play();
            break;
            case 3:
            death4.play();
            break;
            case 4:
            death5.play();
            break;
            case 5:
            death6.play();
            break;
        }
    }

    /**
     * Method that allows a bus to drag dead pedestrians off screen
     */
    public void drag()
    {
        if (isDead == true)
        {
            Draggers b = (Draggers)getOneIntersectingObject(Draggers.class);

            if (b != null)
            {
                setLocation(b.getX() - 20, b.getY());
                if (dragged == false)
                {
                    setRotation(270);
                    playDeathSound();
                    dragged = true;
                }
            }
        }
    }
}
